﻿using Monkeys.Helpers;
using Monkeys.Models;
using System.Collections.ObjectModel;
using System.Linq;
using System.Windows.Input;
using Xamarin.Forms;
using System;

namespace Monkeys.ViewModels
{
    public class MonkeysViewModel
    {
        public ObservableCollection<Monkey> Monkeys { get; set; }
        public ObservableCollection<Grouping<string, Monkey>> MonkeysGrouped { get; set; }

        public ICommand ImageTapCommand { get; private set; }

        public MonkeysViewModel()
        {
            
            Monkeys = MonkeyHelper.Monkeys;
            MonkeysGrouped = MonkeyHelper.MonkeysGrouped;
            ImageTapCommand = new Command(ImageTapped);
        }

        public int MonkeyCount => Monkeys.Count;

        async void ImageTapped(object obj)
        {
            var monkey = obj as Monkey;

            await Application.Current.MainPage.DisplayAlert($"Image Tapped: {monkey.Name}", $"{monkey.Location}", "OK");
        }
    }
}



